#ifndef __INC_POS_PINTUI_TAGS_H
#define __INC_POS_PINTUI_TAGS_H
/*******************************************************************
 Includes Release 24
 (C) Copyright 1995-1997 proDAD
     All Rights Reserved

 $AUT Holger Burkarth
 $DAT >>Tags.h<<   28 Feb 1997    15:22:36 - (C) ProDAD
*******************************************************************/
#ifndef __INC_POS_PUTIL_TAGITEM_H
#include <pUtil/TagItem.h>
#endif

enum pOS_IntuiClassTags
{
/** gadget.class / iobjroot.class **/

  ICLTAG_First = TAG_USER + 0x50000,

  ICLTAG_Left,			// (SLONG)
  ICLTAG_Top,			// (SLONG)
  ICLTAG_Width,			// (ULONG)
  ICLTAG_Height,		// (ULONG)
  ICLTAG_RelBottom,		// (SLONG)
  ICLTAG_RelRight,		// (SLONG)
  ICLTAG_RelWidth,		// (SLONG)
  ICLTAG_RelHeight,		// (SLONG)
  ICLTAG_SelectRender,          // (pOS_IntuiObj*) (gad_Select)
  ICLTAG_Disabled,		// (BOOL)
  ICLTAG_GZZGadget,		// (BOOL)
  ICLTAG_ID,    		// (ULONG)
  ICLTAG_UserData,
  ICLTAG_SpecialInfo,
  ICLTAG_Selected,		// (BOOL)
  ICLTAG_Immediate,		// (BOOL)
  ICLTAG_RelVerify,		// (BOOL)
  ICLTAG_FollowMouse,
  ICLTAG_RightBorder,		// (BOOL)
  ICLTAG_LeftBorder,		// (BOOL)
  ICLTAG_TopBorder,		// (BOOL)
  ICLTAG_BottomBorder,		// (BOOL)
  ICLTAG_ToggleSelect,		// (BOOL)
  ICLTAG_SysGadgetType,		// (Type) internal use
  ICLTAG_DrawInfo,		// (const pOS_DrawInfo*)
  ICLTAG_LableTags,		// (const pOS_TagItem*)
  ICLTAG_RenderTags,		// (const pOS_TagItem*)
  ICLTAG_SelectTags,		// (const pOS_TagItem*)
  ICLTAG_LableClassName,	// (const CHAR*)
  ICLTAG_RenderClassName,	// (const CHAR*)
  ICLTAG_SelectClassName,	// (const CHAR*)
  ICLTAG_LableNClass,		// (pOS_NClass*)
  ICLTAG_RenderNClass,		// (pOS_NClass*)
  ICLTAG_SelectNClass,		// (pOS_NClass*)
  ICLTAG_LableNCVer,		// (ULONG) pOS_NClass-Version
  ICLTAG_RenderNCVer,		// (ULONG) pOS_NClass-Version
  ICLTAG_SelectNCVer,		// (ULONG) pOS_NClass-Version
  ICLTAG_FrameType,		// (enum pOS_FrameClassType)
  ICLTAG_MenuType,		// (enum pOS_MenuTagType)
  ICLTAG_GadBorderType,		// (enum pOS_GadgetBorderTypes)
  ICLTAG_TabCycle,		// (BOOL)
  ICLTAG_UpdateGadget,		// (BOOL)
  ICLTAG_Layer,			// (pOS_Layer*)
  ICLTAG_Layout,		// (BOOL) enable gadget-layouting
  ICLTAG_Gwk,			// (ULONG) Layout-Gewicht (default=0)
  ICLTAG_ShortKey,		// (CHAR) Short-Key (default=0)
  ICLTAG_AutoDelete,		// (BOOL) default=FALSE, Gadget wird beim CloseWindow() gelscht
  ICLTAG_Target,		// (APTR) Target-Object => (ICLMTH_Update with ICLTAG_Map)
  ICLTAG_Map,			// (const pOS_TagItem*)
  ICLTAG_HelpID,		// (const CHAR*)
  ICLTAG_AddWidth,		// (SLONG)
  ICLTAG_AddHeight,		// (SLONG)
  ICLTAG_ShortKeyUSStr,		// (const CHAR*)  Underscore='_'
  ICLTAG_LableLayMode,		// (enum pOS_IObjectClassLayout) default=IOBLAY_HVCenter
  ICLTAG_RenderLayMode,		// (enum pOS_IObjectClassLayout) default=IOBLAY_HVCenter
  ICLTAG_StdLableName,		// (const CHAR*)
  ICLTAG_MutualExclude,		// (ULONG)
  ICLTAG_NoSelect,		// (BOOL) default=FALSE
  ICLTAG_FixSize,		// (BOOL) default=FALSE
  ICLTAG_Flags,			// (ULONG)  z.B. gad_Flags
  ICLTAG_AddDropAttName,	// (const CHAR*) Drop-Attribut-String
  ICLTAG_StandardDrop,		// (BOOL) Gadget untersttzt Standard-Drop
  ICLTAG_StandardDrag,		// (BOOL) Gadget untersttzt Standard-Drag
  ICLTAG_AddDragAttName,	// (const CHAR*) Drag-Attribut-String
  ICLTAG_HighlightDropBox,	// (BOOL)
  ICLTAG_FixFocus,		// (BOOL) der Eingabefocus kann nicht mit pOS_ActivateGadget() entzogen werden
  ICLTAG_IgnoreIE,		// (BOOL)
  ICLTAG_PrivateDisable,	// (BOOL) (GFLG_PrivateDisable)
  ICLTAG_Render,		// (pOS_IntuiObj*) (gad_Render)
  ICLTAG_StdCallback,		// (pOS_Callback*) (struct pOS_GadgetCallbackData*) setzt GFLG_StdCallback
  ICLTAG_StdTargetMap,		// (BOOL) stetzt GFLG_StdTargetMap
  ICLTAG_Callback,		// (pOS_Callback*)
  ICLTAG_AnimateGadget,		// (BOOL) erlaubt, da das Gad beim Selekt eine Anim darstellt
  ICLTAG_HighlightFocus,	// (BOOL) der Gadget-Focus wird angezeigt
  ICLTAG_FetchFocus,		// (BOOL) gadget fetch the focus after GadgetUp
  ICLTAG_ShortKeyAction,	// (enum pOS_GadgetTypes & GTYP_GShortKeyMask)
  ICLTAG_KeyRETURN,		// (BOOL) is the gadget active, RETURN is the same as click
  ICLTAG_Lable,			// (pOS_IntuiObj*) (gad_Lable)
  ICLTAG_TstLable,		// (pOS_IntuiObj*) (gad_Lable), is ti_Data==NULL => fail
  ICLTAG_TstRender,		// (pOS_IntuiObj*) (gad_Render), is ti_Data==NULL => fail


/** itext.class  (Basis: iobjroot.class) **/
/** itext2.class (Basis: itext.class) **/
  IOBJTAG_First = TAG_USER + 0x51000,
  IOBJTAG_FGPen,		// (UWORD) FrontPen
  IOBJTAG_BGPen,		// (UWORD) BackPen
  IOBJTAG_DrMd,			// (enum pOS_RastPortDrawMode)
  IOBJTAG_StaticString,		// (const CHAR*)
  IOBJTAG_TextAttr,		// (const pOS_TextAttr*)
  IOBJTAG_Underscore,		// (CHAR)
  IOBJTAG_FGSelPen,		// (UWORD) Select-FrontPen
  IOBJTAG_BGSelPen,		// (UWORD) Select-BackPen
  IOBJTAG_String,		// (const CHAR*)  (es wird eine Kopie angelegt)
  IOBJTAG_IgnoreUnderscore,	// (BOOL) ignore Underscore drawing


/** igfx.class (Basis: iobjroot.class) **/
  IOGFXTAG_First = TAG_USER + 0x51200,
  IOGFXTAG_FileName,		// (const dosname_t*)
  IOGFXTAG_EnvFile,		// (const dosname_t*) in ENV: bzw. ENVARC:
  IOGFXTAG_LowMem,		/* (BOOL) (default=TRUE) TRUE => belegt mglichst wenig Speicherplatz
				** Die Qualitt und die Geschwindigkeit kann sinken
				*/
  IOGFXTAG_RefFrameNum,		// (ULONG) Referenz-Frame
  IOGFXTAG_GfxMap,		/* (const pOS_GfxMap*) */
  IOGFXTAG_CurrLock,		// (const pOS_FileLock*) CurrentDir
  IOGFXTAG_DTObject,		// (const pOS_DataType*)


/** propgad.class (Basis: gadget.class) **/
  PRGADTAG_First = TAG_USER + 0x52000,
  PRGADTAG_Flags,		// (enum pOS_PropGadFlags)
  PRGADTAG_HorizPot,		// (UWORD)
  PRGADTAG_HorizBody,		// (UWORD)
  PRGADTAG_VertPot,		// (UWORD)
  PRGADTAG_VertBody,		// (UWORD)
  PRGADTAG_Total,		// (ULONG)
  PRGADTAG_Visible,		// (ULONG)
  PRGADTAG_Top,			// (ULONG)
  PRGADTAG_CreateUDGads,	// (BOOL)
  PRGADTAG_Fmt,			// (const CHAR*) DoRawFmt
  PRGADTAG_TxtArray,		// (const CHAR**) TextArray
  PRGADTAG_CrtTxtObj,		// (BOOL) TRUE => autom. ein itext-object zum Anzeigen von Txt erzeugen
  PRGADTAG_IntArray,		// (const SLONG**) Array
  PRGADTAG_TopOffset,		// (SLONG) offset of PRGADTAG_Top
  PRGADTAG_MinStdWidth,		// (ULONG) default=1*pOS_DRISTDFAC, GadWidth = pOS_DRIGETSTDWIDTH(dri,_MinStdWidth)
  PRGADTAG_MinStdHeight,	// (ULONG) default=1*pOS_DRISTDFAC
  PRGADTAG_AddTop,		// (SLONG) add ti_Data to actual Top


/** strgad.class (Basis: gadget.class) **/
  STRGADTAG_First = TAG_USER + 0x53000,
  STRGADTAG_MaxChars,		// (UWORD)
  STRGADTAG_String,		// (const CHAR*)
  STRGADTAG_DispPos,		// (UWORD)
  STRGADTAG_StdDragAtt,		// (BOOL) Standard-Drag fr String-Gadget verwenden
  STRGADTAG_StdDropAtt,		// (BOOL) Standard-Drop fr String-Gadget verwenden
  STRGADTAG_CharFilter,		// (const CHAR*) Null-Terminiert
  STRGADTAG_Integer,		// (SLONG)
  STRGADTAG_MinStdWidth,	// (ULONG) default=3*pOS_DRISTDFAC, GadWidth = pOS_DRIGETSTDWIDTH(dri,_MinStdWidth)


/** lvgad.class (Basis: gadget.class) **/
  LVGADTAG_First = TAG_USER + 0x54000,
  LVGADTAG_List,		// (struct pOS_List*) of pOS_GadgetItem
  LVGADTAG_TopItem,		// (pOS_GadgetItem*)
  LVGADTAG_MultiSelect,		// (BOOL) default=FALSE
  LVGADTAG_ReadOnly,		// (BOOL) default=FALSE
  LVGADTAG_AlwaysOne,		// (BOOL) default=FALSE
  LVGADTAG_Space,		// (SLONG) default=1
  LVGADTAG_CursorScroll,	// (BOOL) default=FALSE
  LVGADTAG_CursorSelect,	// (BOOL) default=FALSE
  LVGADTAG_SelectItem,		// (pOS_GadgetItem*)
  LVGADTAG_VSliderGad,		// (pOS_Gadget*)
  LVGADTAG_HSliderGad,		// (pOS_Gadget*)
  LVGADTAG_Key1,		// (BOOL) default=FALSE (DoubleClick, RETURN)
  LVGADTAG_FirstDrawItem,	// (const pOS_GadgetItem*)
  LVGADTAG_LastDrawItem,	// (const pOS_GadgetItem*)
  LVGADTAG_HasNewNodes,		// (BOOL) Liste besitzt weitere/neue Nodes
  LVGADTAG_VAutoGad,		// (ULONG) 0==off,1==on
  LVGADTAG_CalcSlider,		// (BOOL)
  LVGADTAG_HAutoGad,		// (ULONG) 0==off,1==on
  LVGADTAG_HAutoKt,		// (ULONG) space, horiz eine Kette layouten
  LVGADTAG_HCursorStep,		// (ULONG) horiz. Pixelverschiebung bei Cursor Left/Right (default=4)
  LVGADTAG_DeselectItem,	// (pOS_GadgetItem*)
  LVGADTAG_Key2,		// (BOOL) default=FALSE UNUSED
  LVGADTAG_InvalidItem,		// (pOS_GadgetItem*) // Item wurde aus der Liste entfernt
  LVGADTAG_RedrawItem,		// (const pOS_GadgetItem*) // Item neu zeichnen
  LVGADTAG_ResetKetArray,	// (BOOL) // mit aufreihen neu beginnen
  LVGADTAG_DragItem,		// (const pOS_GadgetItem*) [G]
  LVGADTAG_ViewItem,		// (const pOS_GadgetItem*) (Item ins Sichtfeld setzen)
  LVGADTAG_CR,			// (BOOL) // RETURN
  LVGADTAG_ESC,			// (BOOL) // ESC
  LVGADTAG_GadgetTagItem,	// (const pOS_GadgetTagItem*) autom. creating objects
  LVGADTAG_ItemID,		// (ULONG) [ISG]
  LVGADTAG_MinStdWidth,		// (ULONG) default=5*pOS_DRISTDFAC, GadWidth = pOS_DRIGETSTDWIDTH(dri,_MinStdWidth)
  LVGADTAG_MinStdHeight,	// (ULONG) default=3*pOS_DRISTDFAC


/** grpgad.class (Basis: gadget.class) **/
  GRPGADTAG_First = TAG_USER + 0x55000,
  GRPGADTAG_AddGadget,		// (pOS_Gadget*) Add MemberGadget
  GRPGADTAG_RemGadget,		// (pOS_Gadget*) Remove MemberGadget
  GRPGADTAG_MergeMode,		// (BOOL)  default=FALSE
  GRPGADTAG_Horiz,		// (BOOL)
  GRPGADTAG_Vert,		// (BOOL)  default=TRUE
  GRPGADTAG_SpaceHoriz,		// (ULONG) default=2
  GRPGADTAG_SpaceVert,		// (ULONG) default=2
  GRPGADTAG_CenterHoriz,	// (BOOL)  default=FALSE
  GRPGADTAG_CenterVert,		// (BOOL)  default=FALSE
  GRPGADTAG_BorLeft,		// (ULONG) default=0
  GRPGADTAG_BorTop,		// (ULONG) default=0
  GRPGADTAG_BorRight,		// (ULONG) default=0
  GRPGADTAG_BorBottom,		// (ULONG) default=0
  GRPGADTAG_PrivateDisable,	// (BOOL)  TRUE=> die Ableitung kmmert sich um DISABLE
  GRPGADTAG_List,		// (const pOS_List*)
  GRPGADTAG_LDMode,		// (ULONG) default=0 (autom. <slow>), 1==clear, 2==overwrite
  GRPGADTAG_FreeLayout,		// (BOOL)
  GRPGADTAG_AdjustLables,	// (BOOL) default=FALSE, adjust all lables
  GRPGADTAG_TstAddGadget,	// (pOS_Gadget*) Add MemberGadget, is ti_Data==NULL => fail


/** fvgad.class (Basis: lvgad.class) **/
  FVGADTAG_First = TAG_USER + 0x56000,
  FVGADTAG_Lock,		// (pOS_FileLock*) NULL=>clear view, ~0=>no clear view
				// bei Get(), mu der Lock mit pOS_UnlockObject() wieder freigegeben werden
  FVGADTAG_TargetAddPathGad,	// (pOS_Gadget*)
  FVGADTAG_TargetAddFileGad,	// (pOS_Gadget*)
  FVGADTAG_ScanStatus,		/* (ULONG*) [G] ermittelt den aktuellen Status,
				** Bit 0 set => Scan-Task luft
				*/
  FVGADTAG_RemItem,		/* (pOS_FVGadItem*) entfernt und lscht den Item.
				** Der Item MUSS Member der aktuellen List (LVGADTAG_List)
				** sein. ti_Data==Null => keine Reaktion
				*/
  FVGADTAG_AddItem,
  FVGADTAG_QuickAddItem,	/* (const pOS_FVGadItem*) es wird eine Kopie erzeugt
				** und in die private Liste eingereiht. Bei ..Quick..
				** wird der neue Node nicht sofort in die Anzeigeliste
				** bernommen. Mittels ti_Data==~0 wird nur die Anzeige-
				** Liste erstellt.
				** fgt_Name => enthlt den Namen
				*/
  FVGADTAG_Pattern,		// (const dosname_t*) default = "#?"
  FVGADTAG_MultiAssign,		// (BOOL) default = FALSE
  FVGADTAG_ReScan,		// (BOOL)
  FVGADTAG_MatchFiles,		// (BOOL) default=TRUE (Pattern-Matching auf Files anwenden)
  FVGADTAG_MatchDirs,		// (BOOL) default=FALSE
  FVGADTAG_Files,		// (BOOL) default=TRUE (Files werden bearbeitet)
  FVGADTAG_Dirs,		// (BOOL) default=TRUE
  FVGADTAG_FilterInfos,		// (BOOL) default=FALSE
  FVGADTAG_AutoAddDir,		// (BOOL) default=FALSE
  FVGADTAG_DevList,		// (ULONG) default=0, Device-Liste, 1==ein, 2==toggle, 3==aus ohne re-scan
  FVGADTAG_ViewFileItem,	// (const dosname_t*)
  FVGADTAG_SelectFileItem,	// (const dosname_t*)
  FVGADTAG_DbCkFile,		// (BOOL) default=FALSE
  FVGADTAG_DbCkDir,		// (BOOL) default=FALSE
  FVGADTAG_ColorModel,		// (ULONG) default=0, 0==SCRPEN_Background, 1==SCRPEN_LdBackground, 2==SCRPEN_SvBackground



/** pathgad.class (Basis: strgad.class) **/
  PATHGADTAG_First = TAG_USER + 0x57000,
  PATHGADTAG_TargetFVGad,	// (pOS_Gadget*)
  PATHGADTAG_DoParent,		// (BOOL)
  PATHGADTAG_AddPath,		// (const CHAR*)
  PATHGADTAG_CurrLock,		// (const pOS_FileLock*) (CurrentDir) wird vom Gadget nicht gelscht
  PATHGADTAG_Lock,		// (__ARID__ pOS_FileLock*)
  PATHGADTAG_SetPath,		// (const CHAR*)
  PATHGADTAG_TargetFileGad,	// (pOS_Gadget*)
  PATHGADTAG_AutoReScan,	// (BOOL) default=TRUE, GCLMTHR_InputDone lst re-scan aus


/** popupgad.class (Basis: gadget.class + POPUPGADTAG_PopGad) **/
  POPUPGADTAG_First = TAG_USER + 0x58000,
  POPUPGADTAG_PopGad,		// (pOS_Gadget*)
  POPUPGADTAG_MinPopStdWidth,	// (ULONG) (default=2*pOS_DRISTDFAC)
  POPUPGADTAG_MinPopStdHeight,	// (ULONG) (default=1*pOS_DRISTDFAC)
  POPUPGADTAG_MainGadWidth,	// (BOOL) PopUp-Width orientiert sich am MainGad
  POPUPGADTAG_UseOkCode,	// (BOOL) IEGUCODE_Ok beendet den PopUp
  POPUPGADTAG_UseCancelCode,	// (BOOL) IEGUCODE_Cancel
  POPUPGADTAG_MainGadHeight,    // (BOOL)
  POPUPGADTAG_ESC,              // (BOOL) default=TRUE, abort by Esc
  POPUPGADTAG_LayoutMode,	// (enum pOS_IObjectClassLayout) default=IOBLAY_HVCenter
  POPUPGADTAG_MoreTTags,        // (const pOS_TagItem*) Tag, only for this gadget
  POPUPGADTAG_MoreXTags,        // (const pOS_TagItem*) Tag, only for the popup-gadget
  POPUPGADTAG_MinStdWidth,	// (ULONG) (default=2*pOS_DRISTDFAC)
  POPUPGADTAG_AbortCode,	// (enum pOS_InputEventGdUpCode)
  POPUPGADTAG_InactiveCode,	// (enum pOS_InputEventGdUpCode)



/** mxgad.class (Basis: grpgad.class) **/
  MXGADTAG_First = TAG_USER + 0x59000,
  MXGADTAG_StrLabels,		// (const CHAR**)
  MXGADTAG_Active,		// (ULONG)


/** switchgad.class (Basis: gadget.class) **/
  SWTGADTAG_First = TAG_USER + 0x5A000,
  SWTGADTAG_AddGadget,		// (pOS_Gadget*) Add MemberGadget
  SWTGADTAG_RemGadget,		// (pOS_Gadget*) Remove MemberGadget
  SWTGADTAG_ActivateGadget,	// (pOS_Gadget*) show Member
  SWTGADTAG_TstAddGadget,	// (pOS_Gadget*) Add MemberGadget, is ti_Data==NULL => fail


/** gfxgad.class (Basis: gadget.class) **/
  GFXGADTAG_First = TAG_USER + 0x5B000,
  GFXGADTAG_IntuiTicksAnim,	// (BOOL) play Animation alwasy


/** buttongad.class (Basis: gadget.class) **/
  BUTGADTAG_First = TAG_USER + 0x5C000,
  BUTGADTAG_MinStdWidth,	// (ULONG) default=0
  BUTGADTAG_MinStdHeight,	// (ULONG) default=0
  BUTGADTAG_MaxStdWidth,	// (ULONG) default=~0
  BUTGADTAG_MaxStdHeight,	// (ULONG) default=~0






/** Classes without own tags **/

/** iimage.class      (Basis: iobjroot.class)  **/
/** isymbol.class     (Basis: iobjroot.class)  **/
/** txtboxgad.class   (Basis: buttongad.class) **/
/** sysgad.class      (Basis: gadget.class)    **/
/** checkboxgad.class (Basis: gadget.class)    **/
/** bargad.class      (Basis: gadget.class)    **/
/** lvpopupgad.class  (Basis: popupgad.class)  **/
};



#endif
